bbg-gdx-project-setup
=====================

This is my project setup tool for new games using [LibGDX](https://github.com/libgdx/libgdx). It includes a template project containing all the boilerplate code necessary for every project. It has a basic architecture I use in most of my projects setup ready to be used, consisting of screens, world renderer, asset manager, player class and player input with keyboard and controllers. When launched it displays a background image and the button pressed by the player.

My main target platform currently is the OUYA, so the template game contains an Android project for device deployment and a desktop project for development. 

DISCLAIMER: This project is a constant work in progress and does just what I need. I developed and tested it on OS X only. Feel free to use it for whatever you like.

Setting up a new project
------------------------
After cloning the repository you will find a python script file called `gamesetup.py` in the root directory. To create a new project run this command:

`gamesetup.py -p <packagename> -i <internal project name> -d <project display name> -o <output directory>`

* `-p <packagename>`: The main package name of your project. E.g. `com.mygreatcompany.mygreatgame`.
* `-i <internal project name>`: Used for naming the project directories, some classes and other stuff. NAME THIS AS YOU WOULD NAME A CLASS! (i.e. camel-case, no spaces etc.). E.g. `MyGreatGame`.
* `-d <project display name>`: This is the human readable name of your game. This shows up as the title of the game window on desktop and as the display name of the Android app. E.g. "My Great Game".
* `-o <output directory>`: The new project is created in this folder. If it does not exists the script creates it for you.

Additional parameters:

* `-h`: Help
* `-v`: Version information

Open up Eclipse and import the newly created projects using `File > Import... > Import existing projects into workspace` and start making a game.

As an optional step after creating the project, you can use the excellent [LibGDX Project Setup UI](https://github.com/AurelienRibon/gdx-setup-ui) to upgrade the LibGDX libraries to the latest version.

TODO
----
* additional screens (splash, menu, help)
* sound, music
* improve and extend input system
